
;________________________________________________________________________
;
;                             W X - E . A S M
;________________________________________________________________________
;
; This software is available only for non-commercial amateur radio or 
; educational  applications. ALL other uses  prohibited.  This software 
; may be modified only if the resulting code be made publicly available
; and the original author given credit. Contact the author or TAPR for
; information on commercial licenses.
; 
; portions (c) Copyright 1999,  Byon Garrabrant,  N6BG      All  rights  reserved. 
;     WX code Copyright 1999 by Steve Dimse K4HG k4hg@tapr.org
;
; Version 0.01 2/16/99 incomplete program, xmits every minute, no 1 hour rain support
;	an early release to let people look around.....
;________________________________________________________________________

	LIST	P=PIC16F84
	include	"P16F84.INC"
	__CONFIG _HS_OSC & _CP_OFF & _PWRTE_ON & _WDT_OFF

;________________________________________________________________________

	cblock	H'0C'			; system variables
		beacon_counter
		temp
		temp2
		first
		nextXmitL
		nextXmitH
	endc
;________________________________________________________________________

#define	PTT_OUT		PORTA, 2
#define	VALID_OUT	PORTB, 0
#define	VOX_IN		PORTB, 3

;________________________________________________________________________

	ORG	0			; reset vector
	goto	main
;________________________________________________________________________
	ORG	0x04

	include	"MX614.ASM"		; include MX614 Modem code
	include	"TABLES.ASM"		; tables need to stay low in memory
	include	"OPTIONS.ASM"
	include "AX25.ASM"		; AX-25 routines
	include	"BCD.ASM"		; include BCD routine
	include	"PEETCR.ASM"		; include Peet Bros code
	include "SERIAL.ASM"		; include serial input code
;________________________________________________________________________

sendHeader
	movlw	OPT_CALLSIGN_DIGI
	movwf	temp
Packet_Send_Callsign
	movfw	temp
	call	Get_Option
	iorlw	0
	skpnz
	 goto	Packet_Send_Type

	movwf	temp2
	incf	temp, W
	call	Get_Option
	iorlw	0
	clrc
	skpnz
	 setc
 	rlf	temp2, W

	call	AX25_Send_Data
	incf	temp, F
	goto	Packet_Send_Callsign

Packet_Send_Type

	movlw	H'03'
	call	AX25_Send_Data
	movlw	H'F0'
	call	AX25_Send_Data
	return

SendBeacon
	call	AX25_Send_Start
	call	sendHeader

	movlw	OPT_BEACON_OFFSET
	call	Get_Option
	movwf	hex1
Packet_Send_Beacon
	movfw	hex1
	call	Get_Option
	iorlw	0
	skpnz
	 goto	Packet_Beacon_Done
	call	AX25_Send_Data
	incf	hex1, F
	goto	Packet_Send_Beacon

Packet_Beacon_Done
	call	AX25_Send_End
	return

BigDelay			; Long delay routine for flashing LED at startup
	movlw	0xFF
	movwf	hex1
bigDly1
	call	serialDelay
	decfsz	hex1,f
	goto	bigDly1
	return

waitDCD				; Check for VOX high
	btfsc	VOX_IN
	goto	waitDCD
	call	BigDelay
waitDCD1			; recheck a while later to avoid false low
	btfsc	VOX_IN
	goto	waitDCD1
	return			; all clear for transmit...
	
	
main
	movlw	d'1'
	movwf	first			; initialize first packet flag
	movwf	beacon_counter		; initialize beacon counter
					; start at one so first packet includes beacon

	call	serialInit
	call	wxInit
	call	Tone_Init

	bsf	STATUS, RP0		; Select Bank 1
	bcf	PTT_OUT			; make PTT an output
	bcf	VALID_OUT
	bcf	STATUS, RP0		; Select Bank 0
	bcf	PTT_OUT			; release PTT
	bsf	VALID_OUT		; flash valid LED 3 times on reset
	call	BigDelay
	bcf	VALID_OUT	
	call	BigDelay
	bsf	VALID_OUT	
	call	BigDelay
	bcf	VALID_OUT	
	call	BigDelay
	bsf	VALID_OUT	
	call	BigDelay
	bcf	VALID_OUT	

mainLoop
	call	serialReceive		; receive serial byte
	xorlw	'&'			; look at result
	skpz				; if not & (record starts with "&CR&")
	goto	mainLoop		; wait for start of data
	call	wxDecode		; decode data

	btfsc	first,0			; first data string?
	 goto	notFirst
	
	clrf	first			;
	
	movf	rainL,w			; initialize the 1 hr rain offset
	movwf	offsetR1L
	movf	rainH,w
	

notFirst
; add time check here
	movf	timeL,w
	xorwf	nextXmitL,w		; Debug, xmit every minute
	skpnz
	goto	mainLoop
	movf	timeL,w
	movwf	nextXmitL

	call	convertWX
	call	waitDCD
	call	Packet_Send		; Send the packet
	goto	mainLoop		; loop back again

sendHiBCD
	movwf	hex1			; gotta save before we can swap nybbles
	swapf	hex1,w
sendLoBCD
	andlw	0x0f
	addlw	'0'
	call	AX25_Send_Data
	return
	
Packet_Send				; Send the data packet

	bsf	PTT_OUT			; press PTT
	call	AX25_Send_Start

	call	sendHeader
;
;  example target packet:
;_02092148c293s000g000t043r000p000P000h00b10138mU2K
;
; Lots of optimization possible here, if we need bytes later
;
	movlw	'_'
	call 	AX25_Send_Data
	movf	dateH,w
	call	sendHiBCD
	movf	dateH,w
	call	sendLoBCD
	movf	dateL,w
	call	sendHiBCD
	movf	dateL,w
	call	sendLoBCD
	movf	timeH,w
	call	sendHiBCD
	movf	timeH,w
	call	sendLoBCD
	movf	timeL,w
	call	sendHiBCD
	movf	timeL,w
	call	sendLoBCD
	movlw	'c'
	call 	AX25_Send_Data
	movf	directionH,w
	call	sendLoBCD
	movf	directionL,w
	call	sendHiBCD
	movf	directionL,w
	call	sendLoBCD
	movlw	's'
	call 	AX25_Send_Data
	movf	speedH,w
	call	sendLoBCD
	movf	speed,w
	call	sendHiBCD
	movf	speed,w
	call	sendLoBCD
	movlw	'g'
	call 	AX25_Send_Data
	movf	gustH,w
	call	sendLoBCD
	movf	gustL,w
	call	sendHiBCD
	movf	gustL,w
	call	sendLoBCD
	movlw	't'
	call 	AX25_Send_Data
	movf	tempH,w
	call	sendHiBCD
	movf	tempH,w
	call	sendLoBCD
	movf	tempL,w
	call	sendHiBCD
; add 1 hour rain calculation here
	movlw	'r'
	call 	AX25_Send_Data
	movlw	'.'
	call 	AX25_Send_Data
	movlw	'.'
	call 	AX25_Send_Data
	movlw	'.'
	call 	AX25_Send_Data
	movlw	'p'			; No plans to implement 24 hour rain, could save hourly
					;  totals in eeprom memory and do it at some point in future
					;  but not enough RAM localtions available
	call 	AX25_Send_Data
	movlw	'.'
	call 	AX25_Send_Data
	movlw	'.'
	call 	AX25_Send_Data
	movlw	'.'
	call 	AX25_Send_Data
	movlw	'P'
	call 	AX25_Send_Data
	movf	rainH,w
	call	sendLoBCD
	movf	rainL,w
	call	sendHiBCD
	movf	rainL,w
	call	sendLoBCD
	movlw	'h'
	call 	AX25_Send_Data
	movf	humidH,w
	call	sendLoBCD
	movf	humidL,w
	call	sendHiBCD
	movlw	'b'
	call 	AX25_Send_Data
	movf	baroX,w
	call	sendLoBCD
	movf	baroH,w
	call	sendHiBCD
	movf	baroH,w
	call	sendLoBCD
	movf	baroL,w
	call	sendHiBCD
	movf	baroL,w
	call	sendLoBCD
	movlw	'e'			; This identifies the Pic-E
	call 	AX25_Send_Data
	movlw	'U'			; This identifies the type of WX station
	call 	AX25_Send_Data
	movlw	'2'
	call 	AX25_Send_Data
	movlw	'k'
	call 	AX25_Send_Data

	
	call	AX25_Send_End

	decfsz	beacon_counter, F
	 goto	noBeacon

	movlw	OPT_BEACON_RATE		; reset beacon counter
	call	Get_Option
	movwf	beacon_counter

	call	SendBeacon
noBeacon
	bcf	PTT_OUT			; release PTT

	clrf	gustL
	clrf	gustH
	return
;________________________________________________________________________

	END
;________________________________________________________________________


